//
//  OpticonDeviceEvent.hpp
//  opn_driver
//
//  Created by Nima Nourozi on 11/23/15.
//  Copyright (c) 2015 Nima Nourozi. All rights reserved.
//

#ifndef opn_driver_OpticonDeviceEvent_hpp
#define opn_driver_OpticonDeviceEvent_hpp

#include "Event.hpp"
#include <string>

/* The classes below are exported */
#pragma GCC visibility push(default)
class OpticonDeviceEvent : public Event
{
public:
    OpticonDeviceEvent(UInt32 const & EventKind, std::string const & msg, UInt32 const & deviceID) :
    EventKind(EventKind),
    msg(msg),
    deviceID(deviceID)
    {
    }
    
    virtual ~OpticonDeviceEvent() { }
    
    UInt32 const & getEventKind() {
        return EventKind;
    }
    
    UInt32 const & getDeviceId() {
        return deviceID;
    }
    
    std::string const & getMessage() {
        return msg;
    }
    
private:
    UInt32 const & EventKind;
    std::string const & msg;
    UInt32 const & deviceID;
};
#pragma GCC visibility pop
#endif
